/*
 * Copyright (C) 2010 Teleal GmbH, Switzerland
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.teleal.cling.test.data;

import org.teleal.cling.model.meta.Action;
import org.teleal.cling.model.meta.Service;
import org.teleal.cling.model.meta.StateVariable;

import java.lang.reflect.Constructor;

/**
 * @author Christian Bauer
 */
public abstract class SampleService {

    public abstract Action[] getActions();
    public abstract StateVariable[] getStateVariables();

    public <S extends Service> S newInstance(Constructor<S> ctor) {
        try {
            return ctor.newInstance(
                    getActions(), getStateVariables()
            );
        } catch (Exception ex) {
            throw new RuntimeException(ex);
        }
    }

}
